package cn.pluss.platform.controller;

import cn.pluss.platform.agreement.AgreementService;
import cn.pluss.platform.api.PageInfo;
import cn.pluss.platform.api.Result;
import cn.pluss.platform.api.ResultGenerator;
import cn.pluss.platform.constants.ProjectConstant;
import cn.pluss.platform.entity.Agreement;
import cn.pluss.platform.util.StringUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@RestController
@RequestMapping("/agreement")
@Transactional
@Api(value = "Agreement控制类", tags = {"Agreement接口"})
public class AgreementController {

    @Resource
    private AgreementService agreementService;

    @GetMapping
    @ApiOperation(value = "获取全部", notes = "返回分页过后的数据", httpMethod = "GET")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "page", value = "查询页码", paramType = "query", dataType = "Integer", defaultValue = "0"),
            @ApiImplicitParam(name = "size", value = "每页数据量", paramType = "query", dataType = "Integer", defaultValue = "0")
    })
    public Result<PageInfo<Agreement>> list(@RequestParam(defaultValue = "1") Integer page, @RequestParam(defaultValue = "10") Integer size) {
        if (size == null || size == 0) {
            size = ProjectConstant.PAGE_SIZE;
        }
        if (page == null || page == 0) {
            page = 1;
        }
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("pageSize", size);
        map.put("offset", (page - 1) * size);
        List<Agreement> agreementList = agreementService.queryAgreementPage(map);
        Integer count = agreementService.queryAgreementPageCount(map);
        //返回参数
        PageInfo pager = new PageInfo<Agreement>(count.longValue(), (long) StringUtil.getPageCount(count, size), page.longValue(), size.longValue(), agreementList);
        return ResultGenerator.genSuccessResult(pager);
    }

    @PostMapping
    @ApiOperation(value = "添加数据", notes = "添加新的数据", httpMethod = "POST")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "Agreement", value = "待添加的Agreement实例", paramType = "body", dataType = "Agreement", required = true)
    })
    public Result add(@RequestBody Agreement agreement) {
        agreementService.saveAgreement(agreement);
        return ResultGenerator.genSuccessResult();
    }

    @DeleteMapping("/{id}")
    @ApiOperation(value = "删除数据", notes = "根据id删除数据", httpMethod = "DELETE")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "查询的id实例", paramType = "path", dataType = "Integer", required = true)
    })
    public Result delete(@PathVariable Integer id) {
        Agreement agreement = new Agreement();
        agreement.setId(id);
        agreementService.deleteAgreement(agreement);
        return ResultGenerator.genSuccessResult();
    }

    @PutMapping
    @ApiOperation(value = "更新数据", notes = "根据内容更新数据", httpMethod = "PUT")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "Agreement", value = "更新的Agreement实例", paramType = "body", dataType = "Agreement", required = true)
    })
    public Result update(@RequestBody Agreement agreement) {
        agreementService.updateAgreement(agreement);
        return ResultGenerator.genSuccessResult();
    }

    @GetMapping("/getAgreementOne")
    @ApiOperation(value = "获取单个值", notes = "查看单个项目的内容", httpMethod = "GET")
    @ApiImplicitParam(name = "discern", value = "协议标识", paramType = "String", dataType = "discern", required = true)
    public Result<Agreement> detail(String discern) {
        Agreement agreement = new Agreement();
        agreement.setDiscern(discern);
        List<Agreement> queryAgreementList = agreementService.queryAgreementList(agreement);
        if (queryAgreementList != null && queryAgreementList.size() > 0) {
            agreement = queryAgreementList.get(0);
        }
        return ResultGenerator.genSuccessResult(agreement);
    }

}

